

# Actions


The following actions are supported:
+  [CancelJob](API_CancelJob.md) 
+  [CancelQuantumTask](API_CancelQuantumTask.md) 
+  [CreateJob](API_CreateJob.md) 
+  [CreateQuantumTask](API_CreateQuantumTask.md) 
+  [CreateSpendingLimit](API_CreateSpendingLimit.md) 
+  [DeleteSpendingLimit](API_DeleteSpendingLimit.md) 
+  [GetDevice](API_GetDevice.md) 
+  [GetJob](API_GetJob.md) 
+  [GetQuantumTask](API_GetQuantumTask.md) 
+  [ListTagsForResource](API_ListTagsForResource.md) 
+  [SearchDevices](API_SearchDevices.md) 
+  [SearchJobs](API_SearchJobs.md) 
+  [SearchQuantumTasks](API_SearchQuantumTasks.md) 
+  [SearchSpendingLimits](API_SearchSpendingLimits.md) 
+  [TagResource](API_TagResource.md) 
+  [UntagResource](API_UntagResource.md) 
+  [UpdateSpendingLimit](API_UpdateSpendingLimit.md) 

# CancelJob


Cancels an Amazon Braket hybrid job.

## Request Syntax


```
PUT /job/jobArn/cancel HTTP/1.1
```

## URI Request Parameters


The request uses the following URI parameters.

 ** [jobArn](#API_CancelJob_RequestSyntax) **   <a name="braket-CancelJob-request-uri-jobArn"></a>
The ARN of the Amazon Braket hybrid job to cancel.  
Pattern: `arn:aws[a-z\-]*:braket:[a-z0-9\-]+:[0-9]{12}:job/.*`   
Required: Yes

## Request Body


The request does not have a request body.

## Response Syntax


```
HTTP/1.1 200
Content-type: application/json

{
   "cancellationStatus": "string",
   "jobArn": "string"
}
```

## Response Elements


If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [cancellationStatus](#API_CancelJob_ResponseSyntax) **   <a name="braket-CancelJob-response-cancellationStatus"></a>
The status of the hybrid job.  
Type: String  
Valid Values: `CANCELLING | CANCELLED` 

 ** [jobArn](#API_CancelJob_ResponseSyntax) **   <a name="braket-CancelJob-response-jobArn"></a>
The ARN of the Amazon Braket job.  
Type: String  
Pattern: `arn:aws[a-z\-]*:braket:[a-z0-9\-]+:[0-9]{12}:job/.*` 

## Errors


For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
You do not have sufficient permissions to perform this action.  
HTTP Status Code: 403

 ** ConflictException **   
An error occurred due to a conflict.  
HTTP Status Code: 409

 ** InternalServiceException **   
The request failed because of an unknown error.  
HTTP Status Code: 500

 ** ResourceNotFoundException **   
The specified resource was not found.  
HTTP Status Code: 404

 ** ThrottlingException **   
The API throttling rate limit is exceeded.  
HTTP Status Code: 429

 ** ValidationException **   
The input request failed to satisfy constraints expected by Amazon Braket.    
 ** programSetValidationFailures **   
The validation failures in the program set submitted in the request.  
 ** reason **   
The reason for validation failure.
HTTP Status Code: 400

## See Also


For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/braket-2019-09-01/CancelJob) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/braket-2019-09-01/CancelJob) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/braket-2019-09-01/CancelJob) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/braket-2019-09-01/CancelJob) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/braket-2019-09-01/CancelJob) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/braket-2019-09-01/CancelJob) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/braket-2019-09-01/CancelJob) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/braket-2019-09-01/CancelJob) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/braket-2019-09-01/CancelJob) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/braket-2019-09-01/CancelJob) 

# CancelQuantumTask


Cancels the specified task.

## Request Syntax


```
PUT /quantum-task/quantumTaskArn/cancel HTTP/1.1
Content-type: application/json

{
   "clientToken": "string"
}
```

## URI Request Parameters


The request uses the following URI parameters.

 ** [quantumTaskArn](#API_CancelQuantumTask_RequestSyntax) **   <a name="braket-CancelQuantumTask-request-uri-quantumTaskArn"></a>
The ARN of the quantum task to cancel.  
Length Constraints: Minimum length of 0. Maximum length of 256.  
Required: Yes

## Request Body


The request accepts the following data in JSON format.

 ** [clientToken](#API_CancelQuantumTask_RequestSyntax) **   <a name="braket-CancelQuantumTask-request-clientToken"></a>
The client token associated with the cancellation request.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 64.  
Required: Yes

## Response Syntax


```
HTTP/1.1 200
Content-type: application/json

{
   "cancellationStatus": "string",
   "quantumTaskArn": "string"
}
```

## Response Elements


If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [cancellationStatus](#API_CancelQuantumTask_ResponseSyntax) **   <a name="braket-CancelQuantumTask-response-cancellationStatus"></a>
The status of the quantum task.  
Type: String  
Valid Values: `CANCELLING | CANCELLED` 

 ** [quantumTaskArn](#API_CancelQuantumTask_ResponseSyntax) **   <a name="braket-CancelQuantumTask-response-quantumTaskArn"></a>
The ARN of the quantum task.  
Type: String  
Length Constraints: Minimum length of 0. Maximum length of 256.

## Errors


For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
You do not have sufficient permissions to perform this action.  
HTTP Status Code: 403

 ** ConflictException **   
An error occurred due to a conflict.  
HTTP Status Code: 409

 ** InternalServiceException **   
The request failed because of an unknown error.  
HTTP Status Code: 500

 ** ResourceNotFoundException **   
The specified resource was not found.  
HTTP Status Code: 404

 ** ThrottlingException **   
The API throttling rate limit is exceeded.  
HTTP Status Code: 429

 ** ValidationException **   
The input request failed to satisfy constraints expected by Amazon Braket.    
 ** programSetValidationFailures **   
The validation failures in the program set submitted in the request.  
 ** reason **   
The reason for validation failure.
HTTP Status Code: 400

## See Also


For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/braket-2019-09-01/CancelQuantumTask) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/braket-2019-09-01/CancelQuantumTask) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/braket-2019-09-01/CancelQuantumTask) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/braket-2019-09-01/CancelQuantumTask) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/braket-2019-09-01/CancelQuantumTask) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/braket-2019-09-01/CancelQuantumTask) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/braket-2019-09-01/CancelQuantumTask) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/braket-2019-09-01/CancelQuantumTask) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/braket-2019-09-01/CancelQuantumTask) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/braket-2019-09-01/CancelQuantumTask) 

# CreateJob


Creates an Amazon Braket hybrid job.

## Request Syntax


```
POST /job HTTP/1.1
Content-type: application/json

{
   "algorithmSpecification": { 
      "containerImage": { 
         "uri": "string"
      },
      "scriptModeConfig": { 
         "compressionType": "string",
         "entryPoint": "string",
         "s3Uri": "string"
      }
   },
   "associations": [ 
      { 
         "arn": "string",
         "type": "string"
      }
   ],
   "checkpointConfig": { 
      "localPath": "string",
      "s3Uri": "string"
   },
   "clientToken": "string",
   "deviceConfig": { 
      "device": "string"
   },
   "hyperParameters": { 
      "string" : "string" 
   },
   "inputDataConfig": [ 
      { 
         "channelName": "string",
         "contentType": "string",
         "dataSource": { 
            "s3DataSource": { 
               "s3Uri": "string"
            }
         }
      }
   ],
   "instanceConfig": { 
      "instanceCount": number,
      "instanceType": "string",
      "volumeSizeInGb": number
   },
   "jobName": "string",
   "outputDataConfig": { 
      "kmsKeyId": "string",
      "s3Path": "string"
   },
   "roleArn": "string",
   "stoppingCondition": { 
      "maxRuntimeInSeconds": number
   },
   "tags": { 
      "string" : "string" 
   }
}
```

## URI Request Parameters


The request does not use any URI parameters.

## Request Body


The request accepts the following data in JSON format.

 ** [algorithmSpecification](#API_CreateJob_RequestSyntax) **   <a name="braket-CreateJob-request-algorithmSpecification"></a>
Definition of the Amazon Braket job to be created. Specifies the container image the job uses and information about the Python scripts used for entry and training.  
Type: [AlgorithmSpecification](API_AlgorithmSpecification.md) object  
Required: Yes

 ** [associations](#API_CreateJob_RequestSyntax) **   <a name="braket-CreateJob-request-associations"></a>
The list of Amazon Braket resources associated with the hybrid job.  
Type: Array of [Association](API_Association.md) objects  
Array Members: Minimum number of 0 items. Maximum number of 1 item.  
Required: No

 ** [checkpointConfig](#API_CreateJob_RequestSyntax) **   <a name="braket-CreateJob-request-checkpointConfig"></a>
Information about the output locations for hybrid job checkpoint data.  
Type: [JobCheckpointConfig](API_JobCheckpointConfig.md) object  
Required: No

 ** [clientToken](#API_CreateJob_RequestSyntax) **   <a name="braket-CreateJob-request-clientToken"></a>
The client token associated with this request that guarantees that the request is idempotent.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 64.  
Required: Yes

 ** [deviceConfig](#API_CreateJob_RequestSyntax) **   <a name="braket-CreateJob-request-deviceConfig"></a>
The quantum processing unit (QPU) or simulator used to create an Amazon Braket hybrid job.  
Type: [DeviceConfig](API_DeviceConfig.md) object  
Required: Yes

 ** [hyperParameters](#API_CreateJob_RequestSyntax) **   <a name="braket-CreateJob-request-hyperParameters"></a>
Algorithm-specific parameters used by an Amazon Braket hybrid job that influence the quality of the training job. The values are set with a map of JSON key:value pairs, where the key is the name of the hyperparameter and the value is the value of the hyperparameter.  
Do not include any security-sensitive information including account access IDs, secrets, or tokens in any hyperparameter fields. As part of the shared responsibility model, you are responsible for any potential exposure, unauthorized access, or compromise of your sensitive data if caused by security-sensitive information included in the request hyperparameter variable or plain text fields.
Type: String to string map  
Map Entries: Minimum number of 0 items. Maximum number of 100 items.  
Key Length Constraints: Minimum length of 1. Maximum length of 256.  
Value Length Constraints: Minimum length of 1. Maximum length of 2500.  
Value Pattern: `.*`   
Required: No

 ** [inputDataConfig](#API_CreateJob_RequestSyntax) **   <a name="braket-CreateJob-request-inputDataConfig"></a>
A list of parameters that specify the name and type of input data and where it is located.  
Type: Array of [InputFileConfig](API_InputFileConfig.md) objects  
Array Members: Minimum number of 0 items. Maximum number of 20 items.  
Required: No

 ** [instanceConfig](#API_CreateJob_RequestSyntax) **   <a name="braket-CreateJob-request-instanceConfig"></a>
Configuration of the resource instances to use while running the hybrid job on Amazon Braket.  
Type: [InstanceConfig](API_InstanceConfig.md) object  
Required: Yes

 ** [jobName](#API_CreateJob_RequestSyntax) **   <a name="braket-CreateJob-request-jobName"></a>
The name of the Amazon Braket hybrid job.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 50.  
Pattern: `[a-zA-Z0-9](-*[a-zA-Z0-9]){0,50}`   
Required: Yes

 ** [outputDataConfig](#API_CreateJob_RequestSyntax) **   <a name="braket-CreateJob-request-outputDataConfig"></a>
The path to the S3 location where you want to store hybrid job artifacts and the encryption key used to store them.  
Type: [JobOutputDataConfig](API_JobOutputDataConfig.md) object  
Required: Yes

 ** [roleArn](#API_CreateJob_RequestSyntax) **   <a name="braket-CreateJob-request-roleArn"></a>
The Amazon Resource Name (ARN) of an IAM role that Amazon Braket can assume to perform tasks on behalf of a user. It can access user resources, run an Amazon Braket job container on behalf of user, and output results and hybrid job details to the users' s3 buckets.  
Type: String  
Pattern: `arn:aws[a-z\-]*:iam::\d{12}:role/?[a-zA-Z_0-9+=,.@\-_/]+`   
Required: Yes

 ** [stoppingCondition](#API_CreateJob_RequestSyntax) **   <a name="braket-CreateJob-request-stoppingCondition"></a>
 The user-defined criteria that specifies when a hybrid job stops running.  
Type: [JobStoppingCondition](API_JobStoppingCondition.md) object  
Required: No

 ** [tags](#API_CreateJob_RequestSyntax) **   <a name="braket-CreateJob-request-tags"></a>
Tags to be added to the hybrid job you're creating.  
Type: String to string map  
Required: No

## Response Syntax


```
HTTP/1.1 201
Content-type: application/json

{
   "jobArn": "string"
}
```

## Response Elements


If the action is successful, the service sends back an HTTP 201 response.

The following data is returned in JSON format by the service.

 ** [jobArn](#API_CreateJob_ResponseSyntax) **   <a name="braket-CreateJob-response-jobArn"></a>
The ARN of the Amazon Braket hybrid job created.  
Type: String  
Pattern: `arn:aws[a-z\-]*:braket:[a-z0-9\-]+:[0-9]{12}:job/.*` 

## Errors


For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
You do not have sufficient permissions to perform this action.  
HTTP Status Code: 403

 ** ConflictException **   
An error occurred due to a conflict.  
HTTP Status Code: 409

 ** DeviceOfflineException **   
The specified device is currently offline.  
HTTP Status Code: 424

 ** DeviceRetiredException **   
The specified device has been retired.  
HTTP Status Code: 410

 ** InternalServiceException **   
The request failed because of an unknown error.  
HTTP Status Code: 500

 ** ServiceQuotaExceededException **   
The request failed because a service quota is exceeded.  
HTTP Status Code: 402

 ** ThrottlingException **   
The API throttling rate limit is exceeded.  
HTTP Status Code: 429

 ** ValidationException **   
The input request failed to satisfy constraints expected by Amazon Braket.    
 ** programSetValidationFailures **   
The validation failures in the program set submitted in the request.  
 ** reason **   
The reason for validation failure.
HTTP Status Code: 400

## See Also


For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/braket-2019-09-01/CreateJob) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/braket-2019-09-01/CreateJob) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/braket-2019-09-01/CreateJob) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/braket-2019-09-01/CreateJob) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/braket-2019-09-01/CreateJob) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/braket-2019-09-01/CreateJob) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/braket-2019-09-01/CreateJob) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/braket-2019-09-01/CreateJob) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/braket-2019-09-01/CreateJob) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/braket-2019-09-01/CreateJob) 

# CreateQuantumTask


Creates a quantum task.

## Request Syntax


```
POST /quantum-task HTTP/1.1
Content-type: application/json

{
   "action": "string",
   "associations": [ 
      { 
         "arn": "string",
         "type": "string"
      }
   ],
   "clientToken": "string",
   "deviceArn": "string",
   "deviceParameters": "string",
   "experimentalCapabilities": { ... },
   "jobToken": "string",
   "outputS3Bucket": "string",
   "outputS3KeyPrefix": "string",
   "shots": number,
   "tags": { 
      "string" : "string" 
   }
}
```

## URI Request Parameters


The request does not use any URI parameters.

## Request Body


The request accepts the following data in JSON format.

 ** [action](#API_CreateQuantumTask_RequestSyntax) **   <a name="braket-CreateQuantumTask-request-action"></a>
The action associated with the quantum task.  
Type: String  
Required: Yes

 ** [associations](#API_CreateQuantumTask_RequestSyntax) **   <a name="braket-CreateQuantumTask-request-associations"></a>
The list of Amazon Braket resources associated with the quantum task.  
Type: Array of [Association](API_Association.md) objects  
Array Members: Minimum number of 0 items. Maximum number of 1 item.  
Required: No

 ** [clientToken](#API_CreateQuantumTask_RequestSyntax) **   <a name="braket-CreateQuantumTask-request-clientToken"></a>
The client token associated with the request.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 64.  
Required: Yes

 ** [deviceArn](#API_CreateQuantumTask_RequestSyntax) **   <a name="braket-CreateQuantumTask-request-deviceArn"></a>
The ARN of the device to run the quantum task on.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 256.  
Required: Yes

 ** [deviceParameters](#API_CreateQuantumTask_RequestSyntax) **   <a name="braket-CreateQuantumTask-request-deviceParameters"></a>
The parameters for the device to run the quantum task on.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 48000.  
Required: No

 ** [experimentalCapabilities](#API_CreateQuantumTask_RequestSyntax) **   <a name="braket-CreateQuantumTask-request-experimentalCapabilities"></a>
Enable experimental capabilities for the quantum task.  
Type: [ExperimentalCapabilities](API_ExperimentalCapabilities.md) object  
 **Note: **This object is a Union. Only one member of this object can be specified or returned.  
Required: No

 ** [jobToken](#API_CreateQuantumTask_RequestSyntax) **   <a name="braket-CreateQuantumTask-request-jobToken"></a>
The token for an Amazon Braket hybrid job that associates it with the quantum task.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 128.  
Required: No

 ** [outputS3Bucket](#API_CreateQuantumTask_RequestSyntax) **   <a name="braket-CreateQuantumTask-request-outputS3Bucket"></a>
The S3 bucket to store quantum task result files in.  
Type: String  
Length Constraints: Minimum length of 3. Maximum length of 63.  
Required: Yes

 ** [outputS3KeyPrefix](#API_CreateQuantumTask_RequestSyntax) **   <a name="braket-CreateQuantumTask-request-outputS3KeyPrefix"></a>
The key prefix for the location in the S3 bucket to store quantum task results in. For example, `results/`. Must not contain path traversal sequences such as `../` or `./`.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 1024.  
Required: Yes

 ** [shots](#API_CreateQuantumTask_RequestSyntax) **   <a name="braket-CreateQuantumTask-request-shots"></a>
The number of shots to use for the quantum task.  
Type: Long  
Valid Range: Minimum value of 0.  
Required: Yes

 ** [tags](#API_CreateQuantumTask_RequestSyntax) **   <a name="braket-CreateQuantumTask-request-tags"></a>
Tags to be added to the quantum task you're creating.  
Type: String to string map  
Required: No

## Response Syntax


```
HTTP/1.1 201
Content-type: application/json

{
   "quantumTaskArn": "string"
}
```

## Response Elements


If the action is successful, the service sends back an HTTP 201 response.

The following data is returned in JSON format by the service.

 ** [quantumTaskArn](#API_CreateQuantumTask_ResponseSyntax) **   <a name="braket-CreateQuantumTask-response-quantumTaskArn"></a>
The ARN of the quantum task created by the request.  
Type: String  
Length Constraints: Minimum length of 0. Maximum length of 256.

## Errors


For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
You do not have sufficient permissions to perform this action.  
HTTP Status Code: 403

 ** DeviceOfflineException **   
The specified device is currently offline.  
HTTP Status Code: 424

 ** DeviceRetiredException **   
The specified device has been retired.  
HTTP Status Code: 410

 ** InternalServiceException **   
The request failed because of an unknown error.  
HTTP Status Code: 500

 ** ServiceQuotaExceededException **   
The request failed because a service quota is exceeded.  
HTTP Status Code: 402

 ** ThrottlingException **   
The API throttling rate limit is exceeded.  
HTTP Status Code: 429

 ** ValidationException **   
The input request failed to satisfy constraints expected by Amazon Braket.    
 ** programSetValidationFailures **   
The validation failures in the program set submitted in the request.  
 ** reason **   
The reason for validation failure.
HTTP Status Code: 400

## Examples


### OpenQASM 3.0 action example


The following code is an example of the `action` parameter for creating an OpenQASM 3.0 quantum task.

```
{
  "braketSchemaHeader": {
    "name": "braket.ir.openqasm.program",
    "version": "1"
  },
  "source": "OPENQASM 3; qubit[2] q; bit[2] c; h q[0]; cnot q[0], q[1]; c = measure q;"
}
```

### ProgramSet action example


The following code shows the `action` parameter for creating a `ProgramSet` quantum task with two programs: one with three sets of input parameters (theta and phi), and one with no input parameters.

```
{
    "braketSchemaHeader": {
        "name": "braket.ir.openqasm.program_set",
        "version": "1"
    },
    "programs": [
        {
            "braketSchemaHeader": {
                "name": "braket.ir.openqasm.program",
                "version": "1"
            },
            "source": "OPENQASM 3.0;\\ninput float phi;\\ninput float theta;\\nbit[2] b;\\nqubit[2] q;\\nrx(theta) q[0];\\ncnot q[0], q[1];\\nrz(phi) q[1];\\nb[0] = measure q[0];\\nb[1] = measure q[1];",
            "inputs": {
                "theta": [
                    1.23,
                    1.73,
                    0.73
                ],
                "phi": [
                    0.12,
                    -0.38,
                    0.62
                ]
            }
        },
        {
            "braketSchemaHeader": {
                "name": "braket.ir.openqasm.program",
                "version": "1"
            },
            "source": "OPENQASM 3.0;\\nbit[2] b;\\nqubit[2] q;\\nh q[0];\\ncnot q[0], q[1];\\nb[0] = measure q[0];\\nb[1] = measure q[1];",
            "inputs": {}
        }
    ]
}
```

## See Also


For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/braket-2019-09-01/CreateQuantumTask) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/braket-2019-09-01/CreateQuantumTask) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/braket-2019-09-01/CreateQuantumTask) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/braket-2019-09-01/CreateQuantumTask) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/braket-2019-09-01/CreateQuantumTask) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/braket-2019-09-01/CreateQuantumTask) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/braket-2019-09-01/CreateQuantumTask) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/braket-2019-09-01/CreateQuantumTask) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/braket-2019-09-01/CreateQuantumTask) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/braket-2019-09-01/CreateQuantumTask) 

# CreateSpendingLimit


Creates a spending limit for a specified quantum device. Spending limits help you control costs by setting maximum amounts that can be spent on quantum computing tasks within a specified time period. Simulators do not support spending limits.

## Request Syntax


```
POST /spending-limit HTTP/1.1
Content-type: application/json

{
   "clientToken": "string",
   "deviceArn": "string",
   "spendingLimit": "string",
   "tags": { 
      "string" : "string" 
   },
   "timePeriod": { 
      "endAt": number,
      "startAt": number
   }
}
```

## URI Request Parameters


The request does not use any URI parameters.

## Request Body


The request accepts the following data in JSON format.

 ** [clientToken](#API_CreateSpendingLimit_RequestSyntax) **   <a name="braket-CreateSpendingLimit-request-clientToken"></a>
A unique, case-sensitive identifier to ensure that the operation completes no more than one time. If this token matches a previous request, Amazon Braket ignores the request, but does not return an error.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 64.  
Required: Yes

 ** [deviceArn](#API_CreateSpendingLimit_RequestSyntax) **   <a name="braket-CreateSpendingLimit-request-deviceArn"></a>
The Amazon Resource Name (ARN) of the quantum device to apply the spending limit to.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 256.  
Required: Yes

 ** [spendingLimit](#API_CreateSpendingLimit_RequestSyntax) **   <a name="braket-CreateSpendingLimit-request-spendingLimit"></a>
The maximum amount that can be spent on the specified device, in USD.  
Type: String  
Length Constraints: Minimum length of 1.  
Pattern: `\d+(\.\d{1,2})?`   
Required: Yes

 ** [tags](#API_CreateSpendingLimit_RequestSyntax) **   <a name="braket-CreateSpendingLimit-request-tags"></a>
The tags to apply to the spending limit. Each tag consists of a key and an optional value.  
Type: String to string map  
Required: No

 ** [timePeriod](#API_CreateSpendingLimit_RequestSyntax) **   <a name="braket-CreateSpendingLimit-request-timePeriod"></a>
The time period during which the spending limit is active, including start and end dates.  
Type: [TimePeriod](API_TimePeriod.md) object  
Required: No

## Response Syntax


```
HTTP/1.1 201
Content-type: application/json

{
   "spendingLimitArn": "string"
}
```

## Response Elements


If the action is successful, the service sends back an HTTP 201 response.

The following data is returned in JSON format by the service.

 ** [spendingLimitArn](#API_CreateSpendingLimit_ResponseSyntax) **   <a name="braket-CreateSpendingLimit-response-spendingLimitArn"></a>
The Amazon Resource Name (ARN) of the created spending limit.  
Type: String  
Length Constraints: Minimum length of 0. Maximum length of 256.  
Pattern: `arn:aws[a-z\-]*:braket:[a-z0-9\-]+:[0-9]{12}:spending-limit/.*` 

## Errors


For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
You do not have sufficient permissions to perform this action.  
HTTP Status Code: 403

 ** DeviceRetiredException **   
The specified device has been retired.  
HTTP Status Code: 410

 ** InternalServiceException **   
The request failed because of an unknown error.  
HTTP Status Code: 500

 ** ThrottlingException **   
The API throttling rate limit is exceeded.  
HTTP Status Code: 429

 ** ValidationException **   
The input request failed to satisfy constraints expected by Amazon Braket.    
 ** programSetValidationFailures **   
The validation failures in the program set submitted in the request.  
 ** reason **   
The reason for validation failure.
HTTP Status Code: 400

## See Also


For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/braket-2019-09-01/CreateSpendingLimit) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/braket-2019-09-01/CreateSpendingLimit) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/braket-2019-09-01/CreateSpendingLimit) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/braket-2019-09-01/CreateSpendingLimit) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/braket-2019-09-01/CreateSpendingLimit) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/braket-2019-09-01/CreateSpendingLimit) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/braket-2019-09-01/CreateSpendingLimit) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/braket-2019-09-01/CreateSpendingLimit) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/braket-2019-09-01/CreateSpendingLimit) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/braket-2019-09-01/CreateSpendingLimit) 

# DeleteSpendingLimit


Deletes an existing spending limit. This operation permanently removes the spending limit and cannot be undone. After deletion, the associated device becomes unrestricted for spending.

## Request Syntax


```
DELETE /spending-limit/spendingLimitArn/delete HTTP/1.1
```

## URI Request Parameters


The request uses the following URI parameters.

 ** [spendingLimitArn](#API_DeleteSpendingLimit_RequestSyntax) **   <a name="braket-DeleteSpendingLimit-request-uri-spendingLimitArn"></a>
The Amazon Resource Name (ARN) of the spending limit to delete.  
Length Constraints: Minimum length of 0. Maximum length of 256.  
Pattern: `arn:aws[a-z\-]*:braket:[a-z0-9\-]+:[0-9]{12}:spending-limit/.*`   
Required: Yes

## Request Body


The request does not have a request body.

## Response Syntax


```
HTTP/1.1 200
```

## Response Elements


If the action is successful, the service sends back an HTTP 200 response with an empty HTTP body.

## Errors


For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
You do not have sufficient permissions to perform this action.  
HTTP Status Code: 403

 ** InternalServiceException **   
The request failed because of an unknown error.  
HTTP Status Code: 500

 ** ResourceNotFoundException **   
The specified resource was not found.  
HTTP Status Code: 404

 ** ThrottlingException **   
The API throttling rate limit is exceeded.  
HTTP Status Code: 429

 ** ValidationException **   
The input request failed to satisfy constraints expected by Amazon Braket.    
 ** programSetValidationFailures **   
The validation failures in the program set submitted in the request.  
 ** reason **   
The reason for validation failure.
HTTP Status Code: 400

## See Also


For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/braket-2019-09-01/DeleteSpendingLimit) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/braket-2019-09-01/DeleteSpendingLimit) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/braket-2019-09-01/DeleteSpendingLimit) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/braket-2019-09-01/DeleteSpendingLimit) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/braket-2019-09-01/DeleteSpendingLimit) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/braket-2019-09-01/DeleteSpendingLimit) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/braket-2019-09-01/DeleteSpendingLimit) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/braket-2019-09-01/DeleteSpendingLimit) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/braket-2019-09-01/DeleteSpendingLimit) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/braket-2019-09-01/DeleteSpendingLimit) 

# GetDevice


Retrieves the devices available in Amazon Braket.

**Note**  
For backwards compatibility with older versions of BraketSchemas, OpenQASM information is omitted from GetDevice API calls. To get this information the user-agent needs to present a recent version of the BraketSchemas (1.8.0 or later). The Braket SDK automatically reports this for you. If you do not see OpenQASM results in the GetDevice response when using a Braket SDK, you may need to set AWS\$1EXECUTION\$1ENV environment variable to configure user-agent. See the code examples provided below for how to do this for the AWS CLI, Boto3, and the Go, Java, and JavaScript/TypeScript SDKs.

## Request Syntax


```
GET /device/deviceArn HTTP/1.1
```

## URI Request Parameters


The request uses the following URI parameters.

 ** [deviceArn](#API_GetDevice_RequestSyntax) **   <a name="braket-GetDevice-request-uri-deviceArn"></a>
The ARN of the device to retrieve.  
Length Constraints: Minimum length of 1. Maximum length of 256.  
Required: Yes

## Request Body


The request does not have a request body.

## Response Syntax


```
HTTP/1.1 200
Content-type: application/json

{
   "deviceArn": "string",
   "deviceCapabilities": "string",
   "deviceName": "string",
   "deviceQueueInfo": [ 
      { 
         "queue": "string",
         "queuePriority": "string",
         "queueSize": "string"
      }
   ],
   "deviceStatus": "string",
   "deviceType": "string",
   "providerName": "string"
}
```

## Response Elements


If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [deviceArn](#API_GetDevice_ResponseSyntax) **   <a name="braket-GetDevice-response-deviceArn"></a>
The ARN of the device.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 256.

 ** [deviceCapabilities](#API_GetDevice_ResponseSyntax) **   <a name="braket-GetDevice-response-deviceCapabilities"></a>
Details about the capabilities of the device.  
Type: String

 ** [deviceName](#API_GetDevice_ResponseSyntax) **   <a name="braket-GetDevice-response-deviceName"></a>
The name of the device.  
Type: String

 ** [deviceQueueInfo](#API_GetDevice_ResponseSyntax) **   <a name="braket-GetDevice-response-deviceQueueInfo"></a>
The number of quantum tasks and hybrid jobs currently queued on the device.  
Type: Array of [DeviceQueueInfo](API_DeviceQueueInfo.md) objects

 ** [deviceStatus](#API_GetDevice_ResponseSyntax) **   <a name="braket-GetDevice-response-deviceStatus"></a>
The status of the device.  
Type: String  
Valid Values: `ONLINE | OFFLINE | RETIRED` 

 ** [deviceType](#API_GetDevice_ResponseSyntax) **   <a name="braket-GetDevice-response-deviceType"></a>
The type of the device.  
Type: String  
Valid Values: `QPU | SIMULATOR` 

 ** [providerName](#API_GetDevice_ResponseSyntax) **   <a name="braket-GetDevice-response-providerName"></a>
The name of the partner company for the device.  
Type: String

## Errors


For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
You do not have sufficient permissions to perform this action.  
HTTP Status Code: 403

 ** InternalServiceException **   
The request failed because of an unknown error.  
HTTP Status Code: 500

 ** ResourceNotFoundException **   
The specified resource was not found.  
HTTP Status Code: 404

 ** ThrottlingException **   
The API throttling rate limit is exceeded.  
HTTP Status Code: 429

 ** ValidationException **   
The input request failed to satisfy constraints expected by Amazon Braket.    
 ** programSetValidationFailures **   
The validation failures in the program set submitted in the request.  
 ** reason **   
The reason for validation failure.
HTTP Status Code: 400

## Examples


### AWS CLI SDK example


To set AWS\$1EXECUTION\$1ENV environment variable to configure user-agent when using the AWS CLI SDK:

```
% export AWS_EXECUTION_ENV="aws-cli BraketSchemas/1.8.0"
# Or for single execution
% AWS_EXECUTION_ENV="aws-cli BraketSchemas/1.8.0" aws braket <cmd> [options]
```

### Boto3 example


To set AWS\$1EXECUTION\$1ENV environment variable to configure user-agent when using the Boto3:

```
import boto3
import botocore

client = boto3.client("braket", config=botocore.client.Config(user_agent_extra="BraketSchemas/1.8.0"))
```

### JavaScript/TypeScript (SDK v2) example


To set AWS\$1EXECUTION\$1ENV environment variable to configure user-agent when using the JavaScript/TypeScript (SDK v2):

```
import Braket from 'aws-sdk/clients/braket';
const client = new Braket({ region: 'us-west-2', credentials: AWS_CREDENTIALS, customUserAgent: 'BraketSchemas/1.8.0'  });
```

### JavaScript/TypeScript (SDK v3) example


To set AWS\$1EXECUTION\$1ENV environment variable to configure user-agent when using the JavaScript/TypeScript (SDK v3):

```
import { Braket } from '@aws-sdk/client-braket';
const client = new Braket({ region: 'us-west-2', credentials: AWS_CREDENTIALS, customUserAgent: 'BraketSchemas/1.8.0' });
```

### Go SDK example


To set AWS\$1EXECUTION\$1ENV environment variable to configure user-agent when using the Go SDK:

```
os.Setenv("AWS_EXECUTION_ENV", "BraketGo BraketSchemas/1.8.0")
mySession := session.Must(session.NewSession())
svc := braket.New(mySession)
```

### Java SDK example


To set AWS\$1EXECUTION\$1ENV environment variable to configure user-agent when using the Java SDK:

```
ClientConfiguration config = new ClientConfiguration();
config.setUserAgentSuffix("BraketSchemas/1.8.0");
BraketClient braketClient = BraketClientBuilder.standard().withClientConfiguration(config).build();
```

## See Also


For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/braket-2019-09-01/GetDevice) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/braket-2019-09-01/GetDevice) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/braket-2019-09-01/GetDevice) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/braket-2019-09-01/GetDevice) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/braket-2019-09-01/GetDevice) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/braket-2019-09-01/GetDevice) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/braket-2019-09-01/GetDevice) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/braket-2019-09-01/GetDevice) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/braket-2019-09-01/GetDevice) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/braket-2019-09-01/GetDevice) 

# GetJob


Retrieves the specified Amazon Braket hybrid job.

## Request Syntax


```
GET /job/jobArn?additionalAttributeNames=additionalAttributeNames HTTP/1.1
```

## URI Request Parameters


The request uses the following URI parameters.

 ** [additionalAttributeNames](#API_GetJob_RequestSyntax) **   <a name="braket-GetJob-request-uri-additionalAttributeNames"></a>
A list of attributes to return additional information for. Only the QueueInfo additional attribute name is currently supported.   
Valid Values: `QueueInfo` 

 ** [jobArn](#API_GetJob_RequestSyntax) **   <a name="braket-GetJob-request-uri-jobArn"></a>
The ARN of the hybrid job to retrieve.  
Pattern: `arn:aws[a-z\-]*:braket:[a-z0-9\-]+:[0-9]{12}:job/.*`   
Required: Yes

## Request Body


The request does not have a request body.

## Response Syntax


```
HTTP/1.1 200
Content-type: application/json

{
   "algorithmSpecification": { 
      "containerImage": { 
         "uri": "string"
      },
      "scriptModeConfig": { 
         "compressionType": "string",
         "entryPoint": "string",
         "s3Uri": "string"
      }
   },
   "associations": [ 
      { 
         "arn": "string",
         "type": "string"
      }
   ],
   "billableDuration": number,
   "checkpointConfig": { 
      "localPath": "string",
      "s3Uri": "string"
   },
   "createdAt": "string",
   "deviceConfig": { 
      "device": "string"
   },
   "endedAt": "string",
   "events": [ 
      { 
         "eventType": "string",
         "message": "string",
         "timeOfEvent": "string"
      }
   ],
   "failureReason": "string",
   "hyperParameters": { 
      "string" : "string" 
   },
   "inputDataConfig": [ 
      { 
         "channelName": "string",
         "contentType": "string",
         "dataSource": { 
            "s3DataSource": { 
               "s3Uri": "string"
            }
         }
      }
   ],
   "instanceConfig": { 
      "instanceCount": number,
      "instanceType": "string",
      "volumeSizeInGb": number
   },
   "jobArn": "string",
   "jobName": "string",
   "outputDataConfig": { 
      "kmsKeyId": "string",
      "s3Path": "string"
   },
   "queueInfo": { 
      "message": "string",
      "position": "string",
      "queue": "string"
   },
   "roleArn": "string",
   "startedAt": "string",
   "status": "string",
   "stoppingCondition": { 
      "maxRuntimeInSeconds": number
   },
   "tags": { 
      "string" : "string" 
   }
}
```

## Response Elements


If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [algorithmSpecification](#API_GetJob_ResponseSyntax) **   <a name="braket-GetJob-response-algorithmSpecification"></a>
Definition of the Amazon Braket hybrid job created. Provides information about the container image used, and the Python scripts used for training.  
Type: [AlgorithmSpecification](API_AlgorithmSpecification.md) object

 ** [associations](#API_GetJob_ResponseSyntax) **   <a name="braket-GetJob-response-associations"></a>
The list of Amazon Braket resources associated with the hybrid job.  
Type: Array of [Association](API_Association.md) objects

 ** [billableDuration](#API_GetJob_ResponseSyntax) **   <a name="braket-GetJob-response-billableDuration"></a>
The billable time for which the Amazon Braket hybrid job used to complete.  
Type: Integer

 ** [checkpointConfig](#API_GetJob_ResponseSyntax) **   <a name="braket-GetJob-response-checkpointConfig"></a>
Information about the output locations for hybrid job checkpoint data.  
Type: [JobCheckpointConfig](API_JobCheckpointConfig.md) object

 ** [createdAt](#API_GetJob_ResponseSyntax) **   <a name="braket-GetJob-response-createdAt"></a>
The time at which the Amazon Braket hybrid job was created.  
Type: Timestamp

 ** [deviceConfig](#API_GetJob_ResponseSyntax) **   <a name="braket-GetJob-response-deviceConfig"></a>
The primary device used by the Amazon Braket hybrid job.  
Type: [DeviceConfig](API_DeviceConfig.md) object

 ** [endedAt](#API_GetJob_ResponseSyntax) **   <a name="braket-GetJob-response-endedAt"></a>
The time at which the Amazon Braket hybrid job ended.  
Type: Timestamp

 ** [events](#API_GetJob_ResponseSyntax) **   <a name="braket-GetJob-response-events"></a>
Details about the time and type of events occurred related to the Amazon Braket hybrid job.  
Type: Array of [JobEventDetails](API_JobEventDetails.md) objects  
Array Members: Minimum number of 0 items. Maximum number of 20 items.

 ** [failureReason](#API_GetJob_ResponseSyntax) **   <a name="braket-GetJob-response-failureReason"></a>
A description of the reason why an Amazon Braket hybrid job failed, if it failed.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 1024.

 ** [hyperParameters](#API_GetJob_ResponseSyntax) **   <a name="braket-GetJob-response-hyperParameters"></a>
Algorithm-specific parameters used by an Amazon Braket hybrid job that influence the quality of the traiing job. The values are set with a map of JSON key:value pairs, where the key is the name of the hyperparameter and the value is the value of th hyperparameter.  
Type: String to string map  
Map Entries: Minimum number of 0 items. Maximum number of 100 items.  
Key Length Constraints: Minimum length of 1. Maximum length of 256.  
Value Length Constraints: Minimum length of 1. Maximum length of 2500.  
Value Pattern: `.*` 

 ** [inputDataConfig](#API_GetJob_ResponseSyntax) **   <a name="braket-GetJob-response-inputDataConfig"></a>
A list of parameters that specify the name and type of input data and where it is located.  
Type: Array of [InputFileConfig](API_InputFileConfig.md) objects

 ** [instanceConfig](#API_GetJob_ResponseSyntax) **   <a name="braket-GetJob-response-instanceConfig"></a>
The resource instances to use while running the hybrid job on Amazon Braket.  
Type: [InstanceConfig](API_InstanceConfig.md) object

 ** [jobArn](#API_GetJob_ResponseSyntax) **   <a name="braket-GetJob-response-jobArn"></a>
The ARN of the Amazon Braket hybrid job.  
Type: String  
Pattern: `arn:aws[a-z\-]*:braket:[a-z0-9\-]+:[0-9]{12}:job/.*` 

 ** [jobName](#API_GetJob_ResponseSyntax) **   <a name="braket-GetJob-response-jobName"></a>
The name of the Amazon Braket hybrid job.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 50.  
Pattern: `[a-zA-Z0-9](-*[a-zA-Z0-9]){0,50}` 

 ** [outputDataConfig](#API_GetJob_ResponseSyntax) **   <a name="braket-GetJob-response-outputDataConfig"></a>
The path to the S3 location where hybrid job artifacts are stored and the encryption key used to store them there.  
Type: [JobOutputDataConfig](API_JobOutputDataConfig.md) object

 ** [queueInfo](#API_GetJob_ResponseSyntax) **   <a name="braket-GetJob-response-queueInfo"></a>
Queue information for the requested hybrid job. Only returned if `QueueInfo` is specified in the `additionalAttributeNames"` field in the `GetJob` API request.  
Type: [HybridJobQueueInfo](API_HybridJobQueueInfo.md) object

 ** [roleArn](#API_GetJob_ResponseSyntax) **   <a name="braket-GetJob-response-roleArn"></a>
The Amazon Resource Name (ARN) of an IAM role that Amazon Braket can assume to perform tasks on behalf of a user. It can access user resources, run an Amazon Braket job container on behalf of user, and output results and other hybrid job details to the s3 buckets of a user.  
Type: String  
Pattern: `arn:aws[a-z\-]*:iam::\d{12}:role/?[a-zA-Z_0-9+=,.@\-_/]+` 

 ** [startedAt](#API_GetJob_ResponseSyntax) **   <a name="braket-GetJob-response-startedAt"></a>
The time at which the Amazon Braket hybrid job was started.  
Type: Timestamp

 ** [status](#API_GetJob_ResponseSyntax) **   <a name="braket-GetJob-response-status"></a>
The status of the Amazon Braket hybrid job.  
Type: String  
Valid Values: `QUEUED | RUNNING | COMPLETED | FAILED | CANCELLING | CANCELLED` 

 ** [stoppingCondition](#API_GetJob_ResponseSyntax) **   <a name="braket-GetJob-response-stoppingCondition"></a>
The user-defined criteria that specifies when to stop a running hybrid job.  
Type: [JobStoppingCondition](API_JobStoppingCondition.md) object

 ** [tags](#API_GetJob_ResponseSyntax) **   <a name="braket-GetJob-response-tags"></a>
The tags associated with this hybrid job.  
Type: String to string map

## Errors


For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
You do not have sufficient permissions to perform this action.  
HTTP Status Code: 403

 ** InternalServiceException **   
The request failed because of an unknown error.  
HTTP Status Code: 500

 ** ResourceNotFoundException **   
The specified resource was not found.  
HTTP Status Code: 404

 ** ThrottlingException **   
The API throttling rate limit is exceeded.  
HTTP Status Code: 429

 ** ValidationException **   
The input request failed to satisfy constraints expected by Amazon Braket.    
 ** programSetValidationFailures **   
The validation failures in the program set submitted in the request.  
 ** reason **   
The reason for validation failure.
HTTP Status Code: 400

## See Also


For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/braket-2019-09-01/GetJob) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/braket-2019-09-01/GetJob) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/braket-2019-09-01/GetJob) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/braket-2019-09-01/GetJob) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/braket-2019-09-01/GetJob) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/braket-2019-09-01/GetJob) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/braket-2019-09-01/GetJob) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/braket-2019-09-01/GetJob) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/braket-2019-09-01/GetJob) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/braket-2019-09-01/GetJob) 

# GetQuantumTask


Retrieves the specified quantum task.

## Request Syntax


```
GET /quantum-task/quantumTaskArn?additionalAttributeNames=additionalAttributeNames HTTP/1.1
```

## URI Request Parameters


The request uses the following URI parameters.

 ** [additionalAttributeNames](#API_GetQuantumTask_RequestSyntax) **   <a name="braket-GetQuantumTask-request-uri-additionalAttributeNames"></a>
A list of attributes to return additional information for. Only the QueueInfo additional attribute name is currently supported.  
Valid Values: `QueueInfo` 

 ** [quantumTaskArn](#API_GetQuantumTask_RequestSyntax) **   <a name="braket-GetQuantumTask-request-uri-quantumTaskArn"></a>
The ARN of the quantum task to retrieve.  
Length Constraints: Minimum length of 0. Maximum length of 256.  
Required: Yes

## Request Body


The request does not have a request body.

## Response Syntax


```
HTTP/1.1 200
Content-type: application/json

{
   "actionMetadata": { 
      "actionType": "string",
      "executableCount": number,
      "programCount": number
   },
   "associations": [ 
      { 
         "arn": "string",
         "type": "string"
      }
   ],
   "createdAt": "string",
   "deviceArn": "string",
   "deviceParameters": "string",
   "endedAt": "string",
   "experimentalCapabilities": { ... },
   "failureReason": "string",
   "jobArn": "string",
   "numSuccessfulShots": number,
   "outputS3Bucket": "string",
   "outputS3Directory": "string",
   "quantumTaskArn": "string",
   "queueInfo": { 
      "message": "string",
      "position": "string",
      "queue": "string",
      "queuePriority": "string"
   },
   "shots": number,
   "status": "string",
   "tags": { 
      "string" : "string" 
   }
}
```

## Response Elements


If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [actionMetadata](#API_GetQuantumTask_ResponseSyntax) **   <a name="braket-GetQuantumTask-response-actionMetadata"></a>
Metadata about the action performed by the quantum task, including information about the type of action and program counts.  
Type: [ActionMetadata](API_ActionMetadata.md) object

 ** [associations](#API_GetQuantumTask_ResponseSyntax) **   <a name="braket-GetQuantumTask-response-associations"></a>
The list of Amazon Braket resources associated with the quantum task.  
Type: Array of [Association](API_Association.md) objects

 ** [createdAt](#API_GetQuantumTask_ResponseSyntax) **   <a name="braket-GetQuantumTask-response-createdAt"></a>
The time at which the quantum task was created.  
Type: Timestamp

 ** [deviceArn](#API_GetQuantumTask_ResponseSyntax) **   <a name="braket-GetQuantumTask-response-deviceArn"></a>
The ARN of the device the quantum task was run on.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 256.

 ** [deviceParameters](#API_GetQuantumTask_ResponseSyntax) **   <a name="braket-GetQuantumTask-response-deviceParameters"></a>
The parameters for the device on which the quantum task ran.  
Type: String

 ** [endedAt](#API_GetQuantumTask_ResponseSyntax) **   <a name="braket-GetQuantumTask-response-endedAt"></a>
The time at which the quantum task ended.  
Type: Timestamp

 ** [experimentalCapabilities](#API_GetQuantumTask_ResponseSyntax) **   <a name="braket-GetQuantumTask-response-experimentalCapabilities"></a>
Enabled experimental capabilities for the quantum task, if any.  
Type: [ExperimentalCapabilities](API_ExperimentalCapabilities.md) object  
 **Note: **This object is a Union. Only one member of this object can be specified or returned.

 ** [failureReason](#API_GetQuantumTask_ResponseSyntax) **   <a name="braket-GetQuantumTask-response-failureReason"></a>
The reason that a quantum task failed.  
Type: String

 ** [jobArn](#API_GetQuantumTask_ResponseSyntax) **   <a name="braket-GetQuantumTask-response-jobArn"></a>
The ARN of the Amazon Braket job associated with the quantum task.  
Type: String  
Pattern: `arn:aws[a-z\-]*:braket:[a-z0-9\-]+:[0-9]{12}:job/.*` 

 ** [numSuccessfulShots](#API_GetQuantumTask_ResponseSyntax) **   <a name="braket-GetQuantumTask-response-numSuccessfulShots"></a>
The number of successful shots for the quantum task. This is available after a successfully completed quantum task.  
Type: Long

 ** [outputS3Bucket](#API_GetQuantumTask_ResponseSyntax) **   <a name="braket-GetQuantumTask-response-outputS3Bucket"></a>
The S3 bucket where quantum task results are stored.  
Type: String

 ** [outputS3Directory](#API_GetQuantumTask_ResponseSyntax) **   <a name="braket-GetQuantumTask-response-outputS3Directory"></a>
The folder in the S3 bucket where quantum task results are stored.  
Type: String

 ** [quantumTaskArn](#API_GetQuantumTask_ResponseSyntax) **   <a name="braket-GetQuantumTask-response-quantumTaskArn"></a>
The ARN of the quantum task.  
Type: String  
Length Constraints: Minimum length of 0. Maximum length of 256.

 ** [queueInfo](#API_GetQuantumTask_ResponseSyntax) **   <a name="braket-GetQuantumTask-response-queueInfo"></a>
Queue information for the requested quantum task. Only returned if `QueueInfo` is specified in the `additionalAttributeNames"` field in the `GetQuantumTask` API request.  
Type: [QuantumTaskQueueInfo](API_QuantumTaskQueueInfo.md) object

 ** [shots](#API_GetQuantumTask_ResponseSyntax) **   <a name="braket-GetQuantumTask-response-shots"></a>
The number of shots used in the quantum task.  
Type: Long

 ** [status](#API_GetQuantumTask_ResponseSyntax) **   <a name="braket-GetQuantumTask-response-status"></a>
The status of the quantum task.  
Type: String  
Valid Values: `CREATED | QUEUED | RUNNING | COMPLETED | FAILED | CANCELLING | CANCELLED` 

 ** [tags](#API_GetQuantumTask_ResponseSyntax) **   <a name="braket-GetQuantumTask-response-tags"></a>
The tags that belong to this quantum task.  
Type: String to string map

## Errors


For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
You do not have sufficient permissions to perform this action.  
HTTP Status Code: 403

 ** InternalServiceException **   
The request failed because of an unknown error.  
HTTP Status Code: 500

 ** ResourceNotFoundException **   
The specified resource was not found.  
HTTP Status Code: 404

 ** ThrottlingException **   
The API throttling rate limit is exceeded.  
HTTP Status Code: 429

 ** ValidationException **   
The input request failed to satisfy constraints expected by Amazon Braket.    
 ** programSetValidationFailures **   
The validation failures in the program set submitted in the request.  
 ** reason **   
The reason for validation failure.
HTTP Status Code: 400

## See Also


For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/braket-2019-09-01/GetQuantumTask) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/braket-2019-09-01/GetQuantumTask) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/braket-2019-09-01/GetQuantumTask) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/braket-2019-09-01/GetQuantumTask) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/braket-2019-09-01/GetQuantumTask) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/braket-2019-09-01/GetQuantumTask) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/braket-2019-09-01/GetQuantumTask) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/braket-2019-09-01/GetQuantumTask) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/braket-2019-09-01/GetQuantumTask) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/braket-2019-09-01/GetQuantumTask) 

# ListTagsForResource


Shows the tags associated with this resource.

## Request Syntax


```
GET /tags/resourceArn HTTP/1.1
```

## URI Request Parameters


The request uses the following URI parameters.

 ** [resourceArn](#API_ListTagsForResource_RequestSyntax) **   <a name="braket-ListTagsForResource-request-uri-resourceArn"></a>
Specify the `resourceArn` for the resource whose tags to display.  
Required: Yes

## Request Body


The request does not have a request body.

## Response Syntax


```
HTTP/1.1 200
Content-type: application/json

{
   "tags": { 
      "string" : "string" 
   }
}
```

## Response Elements


If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [tags](#API_ListTagsForResource_ResponseSyntax) **   <a name="braket-ListTagsForResource-response-tags"></a>
Displays the key, value pairs of tags associated with this resource.  
Type: String to string map

## Errors


For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** InternalServiceException **   
The request failed because of an unknown error.  
HTTP Status Code: 500

 ** ResourceNotFoundException **   
The specified resource was not found.  
HTTP Status Code: 404

 ** ValidationException **   
The input request failed to satisfy constraints expected by Amazon Braket.    
 ** programSetValidationFailures **   
The validation failures in the program set submitted in the request.  
 ** reason **   
The reason for validation failure.
HTTP Status Code: 400

## See Also


For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/braket-2019-09-01/ListTagsForResource) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/braket-2019-09-01/ListTagsForResource) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/braket-2019-09-01/ListTagsForResource) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/braket-2019-09-01/ListTagsForResource) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/braket-2019-09-01/ListTagsForResource) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/braket-2019-09-01/ListTagsForResource) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/braket-2019-09-01/ListTagsForResource) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/braket-2019-09-01/ListTagsForResource) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/braket-2019-09-01/ListTagsForResource) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/braket-2019-09-01/ListTagsForResource) 

# SearchDevices


Searches for devices using the specified filters.

## Request Syntax


```
POST /devices HTTP/1.1
Content-type: application/json

{
   "filters": [ 
      { 
         "name": "string",
         "values": [ "string" ]
      }
   ],
   "maxResults": number,
   "nextToken": "string"
}
```

## URI Request Parameters


The request does not use any URI parameters.

## Request Body


The request accepts the following data in JSON format.

 ** [filters](#API_SearchDevices_RequestSyntax) **   <a name="braket-SearchDevices-request-filters"></a>
Array of SearchDevicesFilter objects to use when searching for devices.  
Type: Array of [SearchDevicesFilter](API_SearchDevicesFilter.md) objects  
Array Members: Minimum number of 0 items. Maximum number of 10 items.  
Required: Yes

 ** [maxResults](#API_SearchDevices_RequestSyntax) **   <a name="braket-SearchDevices-request-maxResults"></a>
The maximum number of results to return in the response.  
Type: Integer  
Valid Range: Minimum value of 1. Maximum value of 100.  
Required: No

 ** [nextToken](#API_SearchDevices_RequestSyntax) **   <a name="braket-SearchDevices-request-nextToken"></a>
A token used for pagination of results returned in the response. Use the token returned from the previous request to continue search where the previous request ended.  
Type: String  
Required: No

## Response Syntax


```
HTTP/1.1 200
Content-type: application/json

{
   "devices": [ 
      { 
         "deviceArn": "string",
         "deviceName": "string",
         "deviceStatus": "string",
         "deviceType": "string",
         "providerName": "string"
      }
   ],
   "nextToken": "string"
}
```

## Response Elements


If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [devices](#API_SearchDevices_ResponseSyntax) **   <a name="braket-SearchDevices-response-devices"></a>
An array of `DeviceSummary` objects for devices that match the specified filter values.  
Type: Array of [DeviceSummary](API_DeviceSummary.md) objects

 ** [nextToken](#API_SearchDevices_ResponseSyntax) **   <a name="braket-SearchDevices-response-nextToken"></a>
A token used for pagination of results, or null if there are no additional results. Use the token value in a subsequent request to continue search where the previous request ended.  
Type: String

## Errors


For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
You do not have sufficient permissions to perform this action.  
HTTP Status Code: 403

 ** InternalServiceException **   
The request failed because of an unknown error.  
HTTP Status Code: 500

 ** ThrottlingException **   
The API throttling rate limit is exceeded.  
HTTP Status Code: 429

 ** ValidationException **   
The input request failed to satisfy constraints expected by Amazon Braket.    
 ** programSetValidationFailures **   
The validation failures in the program set submitted in the request.  
 ** reason **   
The reason for validation failure.
HTTP Status Code: 400

## See Also


For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/braket-2019-09-01/SearchDevices) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/braket-2019-09-01/SearchDevices) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/braket-2019-09-01/SearchDevices) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/braket-2019-09-01/SearchDevices) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/braket-2019-09-01/SearchDevices) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/braket-2019-09-01/SearchDevices) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/braket-2019-09-01/SearchDevices) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/braket-2019-09-01/SearchDevices) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/braket-2019-09-01/SearchDevices) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/braket-2019-09-01/SearchDevices) 

# SearchJobs


Searches for Amazon Braket hybrid jobs that match the specified filter values.

## Request Syntax


```
POST /jobs HTTP/1.1
Content-type: application/json

{
   "filters": [ 
      { 
         "name": "string",
         "operator": "string",
         "values": [ "string" ]
      }
   ],
   "maxResults": number,
   "nextToken": "string"
}
```

## URI Request Parameters


The request does not use any URI parameters.

## Request Body


The request accepts the following data in JSON format.

 ** [filters](#API_SearchJobs_RequestSyntax) **   <a name="braket-SearchJobs-request-filters"></a>
Array of SearchJobsFilter objects to use when searching for hybrid jobs.  
Type: Array of [SearchJobsFilter](API_SearchJobsFilter.md) objects  
Array Members: Minimum number of 0 items. Maximum number of 10 items.  
Required: Yes

 ** [maxResults](#API_SearchJobs_RequestSyntax) **   <a name="braket-SearchJobs-request-maxResults"></a>
The maximum number of results to return in the response.  
Type: Integer  
Valid Range: Minimum value of 1. Maximum value of 100.  
Required: No

 ** [nextToken](#API_SearchJobs_RequestSyntax) **   <a name="braket-SearchJobs-request-nextToken"></a>
A token used for pagination of results returned in the response. Use the token returned from the previous request to continue search where the previous request ended.  
Type: String  
Required: No

## Response Syntax


```
HTTP/1.1 200
Content-type: application/json

{
   "jobs": [ 
      { 
         "createdAt": "string",
         "device": "string",
         "endedAt": "string",
         "jobArn": "string",
         "jobName": "string",
         "startedAt": "string",
         "status": "string",
         "tags": { 
            "string" : "string" 
         }
      }
   ],
   "nextToken": "string"
}
```

## Response Elements


If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [jobs](#API_SearchJobs_ResponseSyntax) **   <a name="braket-SearchJobs-response-jobs"></a>
An array of `JobSummary` objects for devices that match the specified filter values.  
Type: Array of [JobSummary](API_JobSummary.md) objects

 ** [nextToken](#API_SearchJobs_ResponseSyntax) **   <a name="braket-SearchJobs-response-nextToken"></a>
A token used for pagination of results, or `null` if there are no additional results. Use the token value in a subsequent request to continue search where the previous request ended.  
Type: String

## Errors


For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
You do not have sufficient permissions to perform this action.  
HTTP Status Code: 403

 ** InternalServiceException **   
The request failed because of an unknown error.  
HTTP Status Code: 500

 ** ThrottlingException **   
The API throttling rate limit is exceeded.  
HTTP Status Code: 429

 ** ValidationException **   
The input request failed to satisfy constraints expected by Amazon Braket.    
 ** programSetValidationFailures **   
The validation failures in the program set submitted in the request.  
 ** reason **   
The reason for validation failure.
HTTP Status Code: 400

## See Also


For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/braket-2019-09-01/SearchJobs) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/braket-2019-09-01/SearchJobs) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/braket-2019-09-01/SearchJobs) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/braket-2019-09-01/SearchJobs) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/braket-2019-09-01/SearchJobs) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/braket-2019-09-01/SearchJobs) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/braket-2019-09-01/SearchJobs) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/braket-2019-09-01/SearchJobs) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/braket-2019-09-01/SearchJobs) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/braket-2019-09-01/SearchJobs) 

# SearchQuantumTasks


Searches for tasks that match the specified filter values.

## Request Syntax


```
POST /quantum-tasks HTTP/1.1
Content-type: application/json

{
   "filters": [ 
      { 
         "name": "string",
         "operator": "string",
         "values": [ "string" ]
      }
   ],
   "maxResults": number,
   "nextToken": "string"
}
```

## URI Request Parameters


The request does not use any URI parameters.

## Request Body


The request accepts the following data in JSON format.

 ** [filters](#API_SearchQuantumTasks_RequestSyntax) **   <a name="braket-SearchQuantumTasks-request-filters"></a>
Array of `SearchQuantumTasksFilter` objects to use when searching for quantum tasks.  
Type: Array of [SearchQuantumTasksFilter](API_SearchQuantumTasksFilter.md) objects  
Array Members: Minimum number of 0 items. Maximum number of 10 items.  
Required: Yes

 ** [maxResults](#API_SearchQuantumTasks_RequestSyntax) **   <a name="braket-SearchQuantumTasks-request-maxResults"></a>
Maximum number of results to return in the response.  
Type: Integer  
Valid Range: Minimum value of 1. Maximum value of 100.  
Required: No

 ** [nextToken](#API_SearchQuantumTasks_RequestSyntax) **   <a name="braket-SearchQuantumTasks-request-nextToken"></a>
A token used for pagination of results returned in the response. Use the token returned from the previous request to continue search where the previous request ended.  
Type: String  
Required: No

## Response Syntax


```
HTTP/1.1 200
Content-type: application/json

{
   "nextToken": "string",
   "quantumTasks": [ 
      { 
         "createdAt": "string",
         "deviceArn": "string",
         "endedAt": "string",
         "outputS3Bucket": "string",
         "outputS3Directory": "string",
         "quantumTaskArn": "string",
         "shots": number,
         "status": "string",
         "tags": { 
            "string" : "string" 
         }
      }
   ]
}
```

## Response Elements


If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [nextToken](#API_SearchQuantumTasks_ResponseSyntax) **   <a name="braket-SearchQuantumTasks-response-nextToken"></a>
A token used for pagination of results, or null if there are no additional results. Use the token value in a subsequent request to continue search where the previous request ended.  
Type: String

 ** [quantumTasks](#API_SearchQuantumTasks_ResponseSyntax) **   <a name="braket-SearchQuantumTasks-response-quantumTasks"></a>
An array of `QuantumTaskSummary` objects for quantum tasks that match the specified filters.  
Type: Array of [QuantumTaskSummary](API_QuantumTaskSummary.md) objects

## Errors


For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
You do not have sufficient permissions to perform this action.  
HTTP Status Code: 403

 ** InternalServiceException **   
The request failed because of an unknown error.  
HTTP Status Code: 500

 ** ThrottlingException **   
The API throttling rate limit is exceeded.  
HTTP Status Code: 429

 ** ValidationException **   
The input request failed to satisfy constraints expected by Amazon Braket.    
 ** programSetValidationFailures **   
The validation failures in the program set submitted in the request.  
 ** reason **   
The reason for validation failure.
HTTP Status Code: 400

## See Also


For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/braket-2019-09-01/SearchQuantumTasks) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/braket-2019-09-01/SearchQuantumTasks) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/braket-2019-09-01/SearchQuantumTasks) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/braket-2019-09-01/SearchQuantumTasks) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/braket-2019-09-01/SearchQuantumTasks) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/braket-2019-09-01/SearchQuantumTasks) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/braket-2019-09-01/SearchQuantumTasks) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/braket-2019-09-01/SearchQuantumTasks) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/braket-2019-09-01/SearchQuantumTasks) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/braket-2019-09-01/SearchQuantumTasks) 

# SearchSpendingLimits


Searches and lists spending limits based on specified filters. This operation supports pagination and allows filtering by various criteria to find specific spending limits. We recommend using pagination to ensure that the operation returns quickly and successfully.

## Request Syntax


```
POST /spending-limits HTTP/1.1
Content-type: application/json

{
   "filters": [ 
      { 
         "name": "string",
         "operator": "string",
         "values": [ "string" ]
      }
   ],
   "maxResults": number,
   "nextToken": "string"
}
```

## URI Request Parameters


The request does not use any URI parameters.

## Request Body


The request accepts the following data in JSON format.

 ** [filters](#API_SearchSpendingLimits_RequestSyntax) **   <a name="braket-SearchSpendingLimits-request-filters"></a>
The filters to apply when searching for spending limits. Use filters to narrow down the results based on specific criteria.  
Type: Array of [SearchSpendingLimitsFilter](API_SearchSpendingLimitsFilter.md) objects  
Array Members: Minimum number of 0 items. Maximum number of 10 items.  
Required: No

 ** [maxResults](#API_SearchSpendingLimits_RequestSyntax) **   <a name="braket-SearchSpendingLimits-request-maxResults"></a>
The maximum number of results to return in a single call. Minimum value of 1, maximum value of 100. Default is 20.  
Type: Integer  
Valid Range: Minimum value of 1. Maximum value of 100.  
Required: No

 ** [nextToken](#API_SearchSpendingLimits_RequestSyntax) **   <a name="braket-SearchSpendingLimits-request-nextToken"></a>
The token to retrieve the next page of results. This value is returned from a previous call to SearchSpendingLimits when there are more results available.  
Type: String  
Required: No

## Response Syntax


```
HTTP/1.1 200
Content-type: application/json

{
   "nextToken": "string",
   "spendingLimits": [ 
      { 
         "createdAt": "string",
         "deviceArn": "string",
         "queuedSpend": "string",
         "spendingLimit": "string",
         "spendingLimitArn": "string",
         "tags": { 
            "string" : "string" 
         },
         "timePeriod": { 
            "endAt": number,
            "startAt": number
         },
         "totalSpend": "string",
         "updatedAt": "string"
      }
   ]
}
```

## Response Elements


If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [nextToken](#API_SearchSpendingLimits_ResponseSyntax) **   <a name="braket-SearchSpendingLimits-response-nextToken"></a>
The token to retrieve the next page of results. This value is null when there are no more results to return.  
Type: String

 ** [spendingLimits](#API_SearchSpendingLimits_ResponseSyntax) **   <a name="braket-SearchSpendingLimits-response-spendingLimits"></a>
An array of spending limit summaries that match the specified filters.  
Type: Array of [SpendingLimitSummary](API_SpendingLimitSummary.md) objects

## Errors


For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
You do not have sufficient permissions to perform this action.  
HTTP Status Code: 403

 ** InternalServiceException **   
The request failed because of an unknown error.  
HTTP Status Code: 500

 ** ThrottlingException **   
The API throttling rate limit is exceeded.  
HTTP Status Code: 429

 ** ValidationException **   
The input request failed to satisfy constraints expected by Amazon Braket.    
 ** programSetValidationFailures **   
The validation failures in the program set submitted in the request.  
 ** reason **   
The reason for validation failure.
HTTP Status Code: 400

## See Also


For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/braket-2019-09-01/SearchSpendingLimits) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/braket-2019-09-01/SearchSpendingLimits) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/braket-2019-09-01/SearchSpendingLimits) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/braket-2019-09-01/SearchSpendingLimits) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/braket-2019-09-01/SearchSpendingLimits) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/braket-2019-09-01/SearchSpendingLimits) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/braket-2019-09-01/SearchSpendingLimits) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/braket-2019-09-01/SearchSpendingLimits) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/braket-2019-09-01/SearchSpendingLimits) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/braket-2019-09-01/SearchSpendingLimits) 

# TagResource


Add a tag to the specified resource.

## Request Syntax


```
POST /tags/resourceArn HTTP/1.1
Content-type: application/json

{
   "tags": { 
      "string" : "string" 
   }
}
```

## URI Request Parameters


The request uses the following URI parameters.

 ** [resourceArn](#API_TagResource_RequestSyntax) **   <a name="braket-TagResource-request-uri-resourceArn"></a>
Specify the `resourceArn` of the resource to which a tag will be added.  
Required: Yes

## Request Body


The request accepts the following data in JSON format.

 ** [tags](#API_TagResource_RequestSyntax) **   <a name="braket-TagResource-request-tags"></a>
Specify the tags to add to the resource. Tags can be specified as a key-value map.  
Type: String to string map  
Required: Yes

## Response Syntax


```
HTTP/1.1 200
```

## Response Elements


If the action is successful, the service sends back an HTTP 200 response with an empty HTTP body.

## Errors


For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** InternalServiceException **   
The request failed because of an unknown error.  
HTTP Status Code: 500

 ** ResourceNotFoundException **   
The specified resource was not found.  
HTTP Status Code: 404

 ** ValidationException **   
The input request failed to satisfy constraints expected by Amazon Braket.    
 ** programSetValidationFailures **   
The validation failures in the program set submitted in the request.  
 ** reason **   
The reason for validation failure.
HTTP Status Code: 400

## See Also


For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/braket-2019-09-01/TagResource) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/braket-2019-09-01/TagResource) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/braket-2019-09-01/TagResource) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/braket-2019-09-01/TagResource) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/braket-2019-09-01/TagResource) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/braket-2019-09-01/TagResource) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/braket-2019-09-01/TagResource) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/braket-2019-09-01/TagResource) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/braket-2019-09-01/TagResource) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/braket-2019-09-01/TagResource) 

# UntagResource


Remove tags from a resource.

## Request Syntax


```
DELETE /tags/resourceArn?tagKeys=tagKeys HTTP/1.1
```

## URI Request Parameters


The request uses the following URI parameters.

 ** [resourceArn](#API_UntagResource_RequestSyntax) **   <a name="braket-UntagResource-request-uri-resourceArn"></a>
Specify the `resourceArn` for the resource from which to remove the tags.  
Required: Yes

 ** [tagKeys](#API_UntagResource_RequestSyntax) **   <a name="braket-UntagResource-request-uri-tagKeys"></a>
Specify the keys for the tags to remove from the resource.  
Required: Yes

## Request Body


The request does not have a request body.

## Response Syntax


```
HTTP/1.1 200
```

## Response Elements


If the action is successful, the service sends back an HTTP 200 response with an empty HTTP body.

## Errors


For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** InternalServiceException **   
The request failed because of an unknown error.  
HTTP Status Code: 500

 ** ResourceNotFoundException **   
The specified resource was not found.  
HTTP Status Code: 404

 ** ValidationException **   
The input request failed to satisfy constraints expected by Amazon Braket.    
 ** programSetValidationFailures **   
The validation failures in the program set submitted in the request.  
 ** reason **   
The reason for validation failure.
HTTP Status Code: 400

## See Also


For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/braket-2019-09-01/UntagResource) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/braket-2019-09-01/UntagResource) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/braket-2019-09-01/UntagResource) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/braket-2019-09-01/UntagResource) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/braket-2019-09-01/UntagResource) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/braket-2019-09-01/UntagResource) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/braket-2019-09-01/UntagResource) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/braket-2019-09-01/UntagResource) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/braket-2019-09-01/UntagResource) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/braket-2019-09-01/UntagResource) 

# UpdateSpendingLimit


Updates an existing spending limit. You can modify the spending amount or time period. Changes take effect immediately.

## Request Syntax


```
PATCH /spending-limit/spendingLimitArn/update HTTP/1.1
Content-type: application/json

{
   "clientToken": "string",
   "spendingLimit": "string",
   "timePeriod": { 
      "endAt": number,
      "startAt": number
   }
}
```

## URI Request Parameters


The request uses the following URI parameters.

 ** [spendingLimitArn](#API_UpdateSpendingLimit_RequestSyntax) **   <a name="braket-UpdateSpendingLimit-request-uri-spendingLimitArn"></a>
The Amazon Resource Name (ARN) of the spending limit to update.  
Length Constraints: Minimum length of 0. Maximum length of 256.  
Pattern: `arn:aws[a-z\-]*:braket:[a-z0-9\-]+:[0-9]{12}:spending-limit/.*`   
Required: Yes

## Request Body


The request accepts the following data in JSON format.

 ** [clientToken](#API_UpdateSpendingLimit_RequestSyntax) **   <a name="braket-UpdateSpendingLimit-request-clientToken"></a>
A unique, case-sensitive identifier to ensure that the operation completes no more than one time. If this token matches a previous request, Amazon Braket ignores the request, but does not return an error.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 64.  
Required: Yes

 ** [spendingLimit](#API_UpdateSpendingLimit_RequestSyntax) **   <a name="braket-UpdateSpendingLimit-request-spendingLimit"></a>
The new maximum amount that can be spent on the specified device, in USD.  
Type: String  
Length Constraints: Minimum length of 1.  
Pattern: `\d+(\.\d{1,2})?`   
Required: No

 ** [timePeriod](#API_UpdateSpendingLimit_RequestSyntax) **   <a name="braket-UpdateSpendingLimit-request-timePeriod"></a>
The new time period during which the spending limit is active, including start and end dates.  
Type: [TimePeriod](API_TimePeriod.md) object  
Required: No

## Response Syntax


```
HTTP/1.1 200
```

## Response Elements


If the action is successful, the service sends back an HTTP 200 response with an empty HTTP body.

## Errors


For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
You do not have sufficient permissions to perform this action.  
HTTP Status Code: 403

 ** InternalServiceException **   
The request failed because of an unknown error.  
HTTP Status Code: 500

 ** ResourceNotFoundException **   
The specified resource was not found.  
HTTP Status Code: 404

 ** ThrottlingException **   
The API throttling rate limit is exceeded.  
HTTP Status Code: 429

 ** ValidationException **   
The input request failed to satisfy constraints expected by Amazon Braket.    
 ** programSetValidationFailures **   
The validation failures in the program set submitted in the request.  
 ** reason **   
The reason for validation failure.
HTTP Status Code: 400

## See Also


For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/braket-2019-09-01/UpdateSpendingLimit) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/braket-2019-09-01/UpdateSpendingLimit) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/braket-2019-09-01/UpdateSpendingLimit) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/braket-2019-09-01/UpdateSpendingLimit) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/braket-2019-09-01/UpdateSpendingLimit) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/braket-2019-09-01/UpdateSpendingLimit) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/braket-2019-09-01/UpdateSpendingLimit) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/braket-2019-09-01/UpdateSpendingLimit) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/braket-2019-09-01/UpdateSpendingLimit) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/braket-2019-09-01/UpdateSpendingLimit) 